      subroutine classub
      
      parameter	(narray=512)
      character	image*128,daoname*128,list*128
      character*80	galpos,galfile,starfile,cosmicfile
      real		xcen(narray),ycen(narray),mag(narray),sharp(narray)
      real		round(narray)
      real              xgal(2)
      integer         debug
      logical		cosmic,star,gal,galopen
      character*128	string
      
      
      call gproms('image',' ',' ',image,ierr)
      
      if (ierr.ne.0) then
         write(string,'('' CLASSIFY: error reading input name'')')
         call gwrits(string,2)
         return
      end if
      
      call gproms('inputlist','default',' ',list,ierr)
      if (ierr.ne.0) return
      call gproms('galpos',        '',' ',galpos,ierr)
      if (ierr.ne.0) return
      call gproms('galfile',   '.gal',' ',galfile,ierr)
      if (ierr.ne.0) return
      call gpromi('ngal',          1,' ',ngal,ierr)
      if (ierr.ne.0) return
      call gproms('starfile', '.star',' ',starfile,ierr)
      if (ierr.ne.0) return
      call gproms('cosmicfile','.cosmic',' ',cosmicfile,ierr)
      if (ierr.ne.0) return
      call gpromr('fwhmfac',     1.0,' ',fwhmfac,ierr)
      if (ierr.ne.0) return
      call gpromr('sharpobjlo',  0.5,' ',sharpobjlo,ierr)
      if (ierr.ne.0) return
      call gpromr('sharpobjhi',  2.0,' ',sharpobjhi,ierr)
      if (ierr.ne.0) return
      call gpromr('roundobjlo', -1.0,' ',roundobjlo,ierr)
      if (ierr.ne.0) return
      call gpromr('roundobjhi',  1.0,' ',roundobjhi,ierr)
      if (ierr.ne.0) return
      call gpromr('sharpgalhi',  1.0,' ',sharpgalhi,ierr)
      if (ierr.ne.0) return
      call gpromr('sharpcoslo',-100.,' ',sharpcoslo,ierr)
      if (ierr.ne.0) return
      call gpromr('sharpcoshi', 100.,' ',sharpcoshi,ierr)
      if (ierr.ne.0) return
      call gpromr('roundcoslo',-100.,' ',roundcoslo,ierr)
      if (ierr.ne.0) return
      call gpromr('roundcoshi', 100.,' ',roundcoshi,ierr)
      if (ierr.ne.0) return
      call gpromi('verbose',0,' ',debug,ierr)
      if (ierr.ne.0) return
      
      call daofindfile(image,list,daoname,ierr)
      
      if (ierr.ne.0) then
         write(string,
     &        '('' CLASSIFY: DAOFIND cannnot  find input file,'',a)')
     &        image(1:20)
         call gwrits(string,2)
         return
      end if
      if (debug.gt.0) then
         string=' daofile :: '//daoname
         call gwrits(string,2)
      end if
      
      call daoformat(daoname,ierr)
      
      if (ierr.ne.0) then
         string=' CLASSIFY: file not proper format: '//daoname
         call gwrits(string,2)
         return
      end if
      if (debug.gt.0) then
         write(string,'('' format OK '')')
         call gwrits(string,2)
      end if
      
      call daogetpars(daoname,scale,sigma,fwhm,threshold,ierr)
      if (ierr.ne.0) then
         write(string,
     &        '('' CLASSIFY: cannot read parameters from file '')')
         call gwrits(string,2)
         return
      end if
      
      call daogetval(daoname,narray,nimag,xcen,ycen,mag,
     $     sharp,round,ierr)
      if (ierr.ne.0) then
         string=' CLASSIFY: ERROR: cannot read values from file '
         call gwrits(string,2)
         return
      end if
      if (debug.gt.0) then
         write(string,'('' nimag='',i5)') nimag
         call gwrits(string,1)
      end if
      if (nimag.eq.0) then
         string=' CLASSUB: ERROR: no images in coordinate file'
         call gwrits(string,2)
         return
      end if
      
      call daoclose
      
      if (sigma.le.0) then
         write(string,'('' CLASSUB: skynoise <= 0 '',g15.4)') sigma
         call gwrits(string,2)
         sigma=abs(sigma)
         if (sigma.eq.0) sigma=1
      end if
      if (threshold.le.0) then
         write(string,'('' CLASSUB: threshold <= 0 '',g15.4)') threshold
         call gwrits(string,2)
         threshold=abs(threshold)
         if (threshold.eq.0) threshold=1
      end if
      
      call imname(image,galfile)
      call imname(image,starfile)
      call imname(image,cosmicfile)
      gal=galfile.ne.' '
      star=starfile.ne.' '
      cosmic=cosmicfile.ne.' '
      galopen=.false.
      
      igal=0
      imgal=0
      if (galpos.ne.' ') then
         string=galpos
         call arguments(string,2,xgal,narg)
         if (narg.ne.2) then
            string=' CLASSUB: ERROR: cannot read galaxy '//
     $           'positions from '//galpos
            call gwrits(string,2)
            return
         end if
         r2min=1e30
         do 10 i=1,nimag
            r2=(xcen(i)-xgal(1))**2+(ycen(i)-xgal(2))**2
            if (r2.lt.r2min) then
               r2min=r2
               imgal=i
            end if
 10      continue
         write(string,'('' galaxy center at '',2f8.2)') 
     $        xcen(imgal),ycen(imgal)
         call gwrits(string,1)
         if (gal) then
            open(unit=10,file=galfile,status='unknown',
     $           err=999)
            galopen=.true.
            write(10,'(3x,2f9.2)') xcen(imgal),ycen(imgal)
            igal=igal+1
         end if
      end if  
      
      
      
      if (star) open(unit=11,file=starfile,status='unknown',err=999)
      if (cosmic) open(unit=12,file=cosmicfile,status='unknown',
     $     err=999)
      
      alpha=4.
      ra=1./(2.**(1./alpha)-1.)
      
      
      do 20 i=1,nimag
         if (i.ne.imgal) then
            if (round(i).gt.roundobjlo.and.
     $           round(i).lt.roundobjhi.and.
     $           sharp(i).gt.sharpobjlo.and.
     $           sharp(i).lt.sharpobjhi) then
               
c     THIS IS AN OBJECT (STAR OR GALAXY)
               
               if (igal.lt.ngal.and.sharp(i).lt.sharpgalhi) then
c     IT's A GALAXY
                  if (gal) then
                     if (.not.galopen) open(unit=10,file=galfile,
     $                    status='unknown',err=999)
                     galopen=.true.
                     write(10,'(3x,2f9.2)') xcen(i),ycen(i)
                     igal=igal+1
                  end if
               else
c     IT's A STAR
                  if (debug.gt.1) then
                     write(string,'('' CLASSUB: mag= '',g15.4)') 
     $                    mag(i)
                     call gwrits(string,2)
                  end if
                  
                  peak=(10.**(-mag(i)/2.5))*threshold
                  if (debug.gt.1) then
                     write(string,'('' CLASSUB: peak= '',g15.4)') 
     $                    peak
                     call gwrits(string,2)
                  end if
                  if (peak.le.0) then
                     write(string,'('' CLASSUB: peak <= 0 '',g15.4)') 
     $                    peak
                     call gwrits(string,2)
                     goto 20
                  end if
                  
                  sh=sharp(i)/0.7
                  if (sh.lt.0.3) sh=0.3
                  
                  if (sh.gt.1) peak=peak*sh
                  r=ra*((peak/sigma)**(1./alpha) - 1.)
                  if (r.gt.0) then
                     r=sqrt(r)*fwhm/2.
                     r=r/fwhmfac
                  else
                     r=0.5
                  end if
                  if (star) write(11,'(3x,3f9.2)',err=999) 
     $                 xcen(i),ycen(i),r
               end if
            else if (round(i).gt.roundcoslo.and.
     $              round(i).lt.roundcoshi.and.
     $              sharp(i).gt.sharpcoslo.and.
     $              sharp(i).lt.sharpcoshi) then
c     IT IS NOT AN OBJECT - COSMIC RAY 
               r=1.
               if (cosmic) write(12,'(3x,3f9.2)',err=999) 
     $              xcen(i),ycen(i),r
            end if
         end if
 20   continue
      
      if (galopen) close(unit=10,iostat=ierr)
      if (star) close(unit=11,iostat=ierr)
      if (cosmic) close(unit=12,iostat=ierr)
      
      return
 999  string=' CLASSIFY: cannot open output-file(s) or error writing'
      call gwrits(string,2)
      close(unit=10,iostat=ierr)
      close(unit=11,iostat=ierr)
      close(unit=12,iostat=ierr)
      return
      end

