      subroutine getsample(nx, ny, pix, ns, xs, ys, vs, badfrac, ierr)
      
c     this subroutine gets the data values as defined by ns,xs,ys.
c     the values are stored in vs. the input array is pix(nx,ny)
c     the subroutine distinguishes between sampling points along a 
c     simple ellipse, and getting the mean value within an area defined
c     by 4 points.
      
      include 'param.inc'
      
      real	xs(5,MAXSAMP),ys(5,MAXSAMP),vs(MAXSAMP)
      logical accurate
      character*128	string
      
      call startsub('GETSAMPLE')

      if (ns.eq.0) then
         write(string,'('' GETSAMPLE: ERROR: ns=0 '')')
         call gwrits(string,2)
         ierr=1
         return
      end if

      nbad=0
      do 10  is=1,ns
         if (xs(5,is).eq.0.) then
c     4th order interpolation
            call interpd2(nx, ny, pix, xs(1,is), ys(1,is), vs(is))
            xs(5,is)=xs(1,is)
            ys(5,is)=ys(1,is)
         else if (xs(5,is).eq.1.) then
            accurate=.true.
            call square(nx, ny, pix, accurate,
     &           xs(1,is), ys(1,is), vs(is))
         end if
         if (vs(is).lt.VALMIN) nbad=nbad+1
 10   continue
      
      badfrac=float(nbad)/float(ns)
      
      if (debug.ge.10) then
         write(string,'('' GETSAMPLE: pixel values: '')')
         call gwrits(string,1)
         do 20 i=1,ns,6
            write(string,'(10g12.5)') (vs(j),j=i,min(ns,i+5))
            call gwrits(string,1)
 20      continue
      end if
      if (debug.ge.6) then
         write(string,'('' GETSAMPLE:: ns,badfrac=    : '',i5,f10.2)')
     &        ns,badfrac
         call gwrits(string,1)
      end if
      
      ierr=0
      return
      end
