      subroutine getsincos(ns,xs,ys,ls,sts,cts,x,y,r,e,t,igal,ierr)

c     this subroutine calculates the sin & cos of the points/areas
c     defined by xs,ys.

      include 'param.inc'
      include 'declare.inc'
      
      real	xs(5,MAXSAMP),ys(5,MAXSAMP),ls(MAXSAMP)
      real	sts(MAXSAMP),cts(MAXSAMP)
      
      character*128	string
      
      call startsub('GETSINCOS')
      
      ls0=0
      do 10 is=1,ns
         if (xs(5,is).ne.0.or.ys(5,is).ne.0) then
            if (ls(is).ne.ls0) then
               ls0=ls(is)
               ct=cos(t(1,ls0,igal))
               st=sin(t(1,ls0,igal))
               efac=(1.-e(1,ls0,igal))
               if (efac.lt.0.) then
                  write(string,'('' GETSINCOS: ERROR: eps > 1 '')')
                  call gwrits(string,2)
                  ierr=1
                  return
               end if

               efac=sqrt(efac)
               rad=r(1,ls0,igal)
            end if
            xx=xs(5,is)-x(1,ls0,igal)
            yy=ys(5,is)-y(1,ls0,igal)
            cts(is)=( xx*ct+yy*st)*efac
            sts(is)=(-xx*st+yy*ct)/efac
            sq=sqrt(cts(is)*cts(is)+sts(is)*sts(is))
            if (sq.ne.0) then
               cts(is)=cts(is)/sq
               sts(is)=sts(is)/sq
            end if
         end if
 10   continue
      
      if (debug.ge.10) then
         write(string,'('' GETSINCOS:: values of sin(phi) cos(phi):'')')
         call gwrits(string,1)
         do 20 i=1,ns,8
	    write(string,'(8f10.2)') (sts(j),j=i,min(i+7,ns))
	    call gwrits(string,1)
	    write(string,'(8f10.2)') (cts(j),j=i,min(i+7,ns))
	    call gwrits(string,1)
 20      continue
      end if
      
      ierr=0
      return
      end
