      subroutine getslope(nl,r,inten,nhar,s,igal,ierr)
      
c     this subroutine calculates the slope at all points.
c     the slope is calculated by a polynomial fit.


      include 'param.inc'
      include 'declare.inc'
      
      integer  nhar(MAXLINE)
      
      real	intens(MAXLINE), rad(MAXLINE)
      real	coef(10)
      integer	iar(MAXLINE)
      
      character*128	string
      
      call startsub('GETSLOPE')

      npol=5
      npol2=npol/2
      
      if (nl.lt.npol) then
         write(string,'('' GETSLOPE: ERROR: nl < npol '')')
         call gwrits(string,2)
         ierr=1
         return
      end if

      ic=0
      do 10 il=1,nl
         if (nhar(il).ge.0) then
	    ic=ic+1
	    rad(ic)=r(1,il,igal)
	    intens(ic)=inten(1,il,igal)
         end if
         iar(il)=ic
 10   continue
      nc=ic
      
      do 20 il=1,nl
         if (nhar(il).ge.0) then
	    ic=iar(il)
	    ipol=ic-npol2
	    if (ipol.lt.1) ipol=1
	    if (ipol.gt.nc-npol+1) ipol=nc-npol+1
            
	    call polcof(rad(ipol),intens(ipol),npol,coef,ierr)
            if (ierr.ne.0) then
               call gwrits(' GETSLOPE: ERROR: polynomial fit',2)
               return
            end if
            
c     algorithm due to Press et al. page 137
            
	    deriv=0.
	    value=coef(npol)
            
	    do 21 ip=npol-1,1,-1
               deriv=deriv*rad(ic)+value
               value=value*rad(ic)+coef(ip)
 21	    continue
         else
	    deriv=0.
         end if
         
         s(1,il,igal)=deriv
         if (s(1,il,igal).ge.0..and.debug.gt.0) then
            write(string,'('' GETSLOPE: WARNING: slope > 0 '')')
            call gwrits(string,1)
         end if
         
 20   continue
      
      if (debug.ge.10) then
         write(string,'('' GETSLOPE:'')')
         call gwrits(string,1)
         do 30 il=1,nl,10
            write(string,'(10f8.2)')
     &           (inten(1,ilj,igal),ilj=il,min(nl,il+9))
            call gwrits(string,1)
            write(string,'(10f8.2)')
     &           (s(1,ilj,igal),ilj=il,min(nl,il+9))
            call gwrits(string,1)
 30      continue
      end if
      
      ierr=0
      return
      end	
