      subroutine harmonics (nphi, cosphi, sinphi, f,
     &     nhar, har, res, nres, ierr)
      
c     fits up to 8th harmonics to f as a function of phi
c     uses least squares fit. errors are also calculated
      
      include 'param.inc'
      
      real cosphi(nphi),sinphi(nphi),f(nphi),har(2,2,MAXHARM)
      
      parameter (NH=2*MAXHARM-1)
      double precision a (NH, NH), b(NH),deter
      real	func(NH)
      character*128	string
      
      call startsub('HARMONICS')
      
      if (nhar.gt.MAXHARM-1) then
         write(string,'('' HARMONICS: ERROR: hmax too big '')')
         call gwrits(string,2)
         ierr=1
         return
      end if
      
      if (nhar.lt.0) goto 999
      nhar2=2*nhar+1
      
      do 10  i = 1, NH
         b(i) = 0.0
         do 11 j = 1, NH
            a (j, i) = 0.0
 11      continue
 10   continue
      
      
      ngood=0
      do 20 iphi = 1, nphi
         fi=f(iphi)
         if (fi.gt. VALMIN) then
            ngood=ngood+1
            func(1)=1.
            func(2)=cosphi(iphi)
            func(3)=sinphi(iphi)
            do 21 i=4,nhar2,2
               func(i)=func(i-2)*func(2)-func(i-1)*func(3)
               func(i+1)=func(i-2)*func(3)+func(i-1)*func(2)
 21         continue
            do 22 i=1,nhar2
               b(i)=b(i)+fi*func(i)
               do 23 j=1,nhar2
                  a(i,j)=a(i,j)+func(i)*func(j)
 23            continue
 22         continue
         end if
 20   continue
      
      if (ngood.eq.0) then
         write(string,'('' HARMONICS: ERROR: no good data values '')')
         call gwrits(string,2)
         ierr=1
         return
      end if
      
      call dmatinv ( a, NH, nhar2, b, 1, deter)
      
      if (deter.eq.0.) then
         write(string,'('' HARMONICS: ERROR: determinant = 0 '')')
         call gwrits(string,2)
         ierr=1
         return
      end if
      
c     calculate deviation
      
      res=0.
      nres=0
      
      do 40 iphi = 1, nphi
         fi=f(iphi)
         if (fi.gt. VALMIN) then
            func(1)=1.
            func(2)=cosphi(iphi)
            func(3)=sinphi(iphi)
            do 41 i=4,nhar2,2
               func(i)=func(i-2)*func(2)-func(i-1)*func(3)
               func(i+1)=func(i-2)*func(3)+func(i-1)*func(2)
 41         continue
            do 42 i=1,nhar2
               fi=fi-b(i)*func(i)
 42         continue
            res=res+fi*fi
            nres=nres+1
         end if
 40   continue
      
      if (nres.ne.0) then
         res=res/nres
      else
         write(string,'('' HARMONICS: ERROR: no good data values '')')
         call gwrits(string,2)
         ierr=1
         return
      end if
      
      har(1,1,1)=b(1)
      a(1,1)=dabs(a(1,1))
      har(2,1,1)=dsqrt(a(1,1)*res)
      
      do 50 i=1,nhar
         do 51 ih=1,2
            ih2=2.*i+ih-1
            har(1,ih,i+1)=b(ih2)
            a(ih2,ih2)=dabs(a(ih2,ih2))
            har(2,ih,i+1)=dsqrt(a(ih2,ih2)*res)
 51      continue
 50   continue
      
      res=sqrt(res)
      
 999  nhar1=nhar+1
      if (nhar1.lt.0) nhar1=0
      do 100 i=nhar1,MAXHARM-1
         do 101 ih=1,2
            har(1,ih,i+1)=0.
            har(2,ih,i+1)=0.
 101     continue
 100  continue
      
      if (debug.ge.5) then
         do 110 i=1,nhar+1,2
            write(string,'('' HARMONICS: '',5(4g12.4))')
     &           ((har(1,ih,ij),ih=1,2),ij=i,min(i+1,nhar+1))
            call gwrits(string,1)
 110     continue
      end if
      
      ierr=0
      return
      end
