
	Subroutine MATINV(A,L,N,B,M,Determ)
C
C  Inverts matrix A and solves linear equations A.C(I)=B(I) for I=1,M
C  Inverted matrix is returned in A and resultant vectors in B
C
C N is size of matrix (N < 20)
C M is number of vector equations to solve (if M <= 0 no equations
C    are solved)
C Determ is determinant, if Determ=0.0 then inversion has failed
C
C  Uses Gaussian elimination with optimised pivots
C
      Integer  N,L,M
	Real*4 Pivot,Temp,Determ,A(L,L),B(L,1)
C
	DIMENSION Index(2,20)
	LOGICAl Lpivot(20)
	Determ=1.0
	DO 1 I=1,N
    1	  Lpivot(I)=.FALSE.
C
	DO 1000 I=1,N
	  PIVOT=0.0
C
C Search for pivot element
C
	  DO 10 J=1,N
	    IF(Lpivot(J)) GOTO 10
	    DO 5 K=1,N
	      IF(Lpivot(K)) GOTO 5
	      IF(abs(PIVOT).GE.abs(A(K,J))) GOTO 5
	      PIVOT=A(K,J)
	      Irow=J
	      Icolum=K
    5	      CONTINUE
   10	    CONTINUE
	  Determ=Determ*PIVOT
	  IF(PIVOT.EQ.0.0) Return
	  Lpivot(Icolum)=.TRUE.
	  Index(1,I)=Irow
	  Index(2,I)=Icolum
C
C Interchange rows to put pivot element on diagonal
C
	  IF(Irow.EQ.Icolum) GOTO 23
	  Determ=-Determ
	  DO 20 J=1,N
	    Temp=A(J,Irow)
	    A(J,Irow)=A(J,Icolum)
   20	    A(J,Icolum)=Temp
	  IF(M.LE.0) GOTO 23
	  DO 22 J=1,M
	    Temp=B(Irow,J)
	    B(Irow,J)=B(Icolum,J)
	    B(Icolum,J)=Temp
   22	    CONTINUE
   23	  CONTINUE
C
C Divide pivot row by pivot element
C
	  A(Icolum,Icolum)=1.0
	  DO 30 J=1,N
   30	    A(J,Icolum)=A(J,Icolum)/PIVOT
	  IF(M.LE.0) GOTO 33
	  DO 31 J=1,M
   31	    B(Icolum,J)=B(Icolum,J)/PIVOT
   33	  CONTINUE
C
C Subtract pivot row from other rows
C
	  DO 50 J=1,N
	    IF(J.EQ.Icolum) GOTO 50
	    Temp=A(Icolum,J)
	    A(Icolum,J)=0.0
	    DO 40 K=1,N
   40	      A(K,J)=A(K,J)-A(K,Icolum)*Temp
	    IF(M.LE.0) GOTO 50
	    DO 42 K=1,M
   42	      B(J,K)=B(J,K)-B(Icolum,K)*Temp
   50	    CONTINUE
C
 1000	  CONTINUE
C
C Interchange columns
C
	K=N+1
	DO 2000 I=1,N
	  K=K-1
	  IF(Index(1,K).EQ.Index(2,K)) GOTO 2000
	  Irow=Index(1,K)
	  Icolum=Index(2,K)
	  DO 1500 J=1,N
	    Temp=A(Irow,J)
	    A(Irow,J)=A(Icolum,J)
 1500	    A(Icolum,J)=Temp
 2000	  CONTINUE
C
	Return
	End


	Subroutine DMATINV(A,L,N,B,M,Determ)
C
C  Inverts matrix A and solves linear equations A.C(I)=B(I) for I=1,M
C  Inverted matrix is returned in A and resultant vectors in B
C
C N is size of matrix (N < 20)
C M is number of vector equations to solve (if M <= 0 no equations
C    are solved)
C Determ is determinant, if Determ=0.0 then inversion has failed
C
C  Uses Gaussian elimination with optimised pivots
C
      Integer  N,L,M
	Real*8 Pivot,Temp,Determ,A(L,L),B(L,1)
C
	DIMENSION Index(2,20)
	LOGICAl Lpivot(20)
	Determ=1.0D0
	DO 1 I=1,N
    1	  Lpivot(I)=.FALSE.
C
	DO 1000 I=1,N
	  PIVOT=0.0D0
C
C Search for pivot element
C
	  DO 10 J=1,N
	    IF(Lpivot(J)) GOTO 10
	    DO 5 K=1,N
	      IF(Lpivot(K)) GOTO 5
	      IF(Dabs(PIVOT).GE.Dabs(A(K,J))) GOTO 5
	      PIVOT=A(K,J)
	      Irow=J
	      Icolum=K
    5	      CONTINUE
   10	    CONTINUE
	  Determ=Determ*PIVOT
	  IF(PIVOT.EQ.0.0D0) Return
	  Lpivot(Icolum)=.TRUE.
	  Index(1,I)=Irow
	  Index(2,I)=Icolum
C
C Interchange rows to put pivot element on diagonal
C
	  IF(Irow.EQ.Icolum) GOTO 23
	  Determ=-Determ
	  DO 20 J=1,N
	    Temp=A(J,Irow)
	    A(J,Irow)=A(J,Icolum)
   20	    A(J,Icolum)=Temp
	  IF(M.LE.0) GOTO 23
	  DO 22 J=1,M
	    Temp=B(Irow,J)
	    B(Irow,J)=B(Icolum,J)
	    B(Icolum,J)=Temp
   22	    CONTINUE
   23	  CONTINUE
C
C Divide pivot row by pivot element
C
	  A(Icolum,Icolum)=1.0D0
	  DO 30 J=1,N
   30	    A(J,Icolum)=A(J,Icolum)/PIVOT
	  IF(M.LE.0) GOTO 33
	  DO 31 J=1,M
   31	    B(Icolum,J)=B(Icolum,J)/PIVOT
   33	  CONTINUE
C
C Subtract pivot row from other rows
C
	  DO 50 J=1,N
	    IF(J.EQ.Icolum) GOTO 50
	    Temp=A(Icolum,J)
	    A(Icolum,J)=0.0D0
	    DO 40 K=1,N
   40	      A(K,J)=A(K,J)-A(K,Icolum)*Temp
	    IF(M.LE.0) GOTO 50
	    DO 42 K=1,M
   42	      B(J,K)=B(J,K)-B(Icolum,K)*Temp
   50	    CONTINUE
C
 1000	  CONTINUE
C
C Interchange columns
C
	K=N+1
	DO 2000 I=1,N
	  K=K-1
	  IF(Index(1,K).EQ.Index(2,K)) GOTO 2000
	  Irow=Index(1,K)
	  Icolum=Index(2,K)
	  DO 1500 J=1,N
	    Temp=A(Irow,J)
	    A(Irow,J)=A(Icolum,J)
 1500	    A(Icolum,J)=Temp
 2000	  CONTINUE
C
	Return
	End
