      subroutine modelx(nx,ny,pix,ngal,nl,inten,s,x,y,r,e,t,h,nhmax,
     &     ldif,lmag,dif,ellipfit,ierr)
      
c     subroutine calculates the pixel values as defined by r,e,t,i,h
c     several call to deeper subroutines which do the actual work
      
      
      include 'param.inc'
      include 'declare.inc'
      
      real	pix(nx,ny),dif(nx,ny)
      integer nl(ngal),nhmax
      logical	ldif,ellipfit,lmag
      
      real	hc(MAXHARM,MAXLINE),hs(MAXHARM,MAXLINE)
      real	st(MAXHARM),ct(MAXHARM)
      real	cxx(MAXLINE),cxy(MAXLINE),cyy(MAXLINE)
      
      logical out,circle
      character*128	string
      
      call startsub('MODEL')
      
      do 1  igal=1,ngal
         
         if (debug.ge.2) then
            write(string,'('' MODEL: initialize nhmax='',i5)') nhmax
            call gwrits(string,1)
         end if
         call modelinit(igal,nl(igal),inten,s,r,e,t,h,cxx,cxy,cyy,
     &        nhmax,hc,hs,circle,ierr)
         if (ierr.ne.0) return

         if (debug.ge.2) then
            write(string,'('' MODEL: initialize ok'')') 
            call gwrits(string,1)
         end if
           
         do 20 iy=1,ny
            do 21 ix=1,nx
               xi=float(ix)
               yi=float(iy)
               
               if (.not.circle) then
                  call modelvalue(xi,yi,igal,nl(igal),x,y,r,inten,
     &                 cxx,cxy,cyy,nhmax,hc,hs,pixval,ierr)
               else
                  call harmvalue(xi,yi,igal,nl(igal),x,y,r,inten,
     &                 cxx,cxy,cyy,nhmax,hc,hs,pixval,ierr)
               end if
               if (ierr.ne.0) return
               
               if (debug.ge.12) then
		  write(string,'(2i8,10g8.2)') ix, iy, xi, yi, pixval
		  call gwrits(string,1)
               end if
               
               if (igal.eq.1) then
                  if (ldif) then
                     if (pix(ix,iy).gt.VALMIN.and.pixval.gt.VALMIN) then
                        dif(ix,iy)=pix(ix,iy)-pixval
                     else
                        dif(ix,iy)=VALBAD
                     end if
                  end if
                  if (lmag) then
                    if (pix(ix,iy).lt.VALMIN.and.pixval.gt.VALMIN) then
                      dif(ix,iy)=pixval
                    else
                      dif(ix,iy)=pix(ix,iy)
                    end if
                  else
                    dif(ix,iy)=pixval
                  end if
               else
                  if (dif(ix,iy).gt.VALMIN) then
                     if (ldif) then
                        dif(ix,iy)=dif(ix,iy)-pixval
                     else
                        dif(ix,iy)=dif(ix,iy)+pixval
                     end if
                  end if
               end if
 21         continue
 20      continue
         
 1    continue

      ierr=0
      return
      end
