      subroutine modmx


      include 'param.inc'
      include 'declare.inc'
      include 'array.inc'
      include 'moddeclare.inc'
      include 'modshort.inc'

      character*128	image,output,intable,deletion,outtable
      character*128	string
      integer		ngal, inhmax

      integer		nl(MAXGAL)
      logical		ellipsefit

      character*60	object

      call gproms('image',' ',' ',image,ierr)
      if (ierr.ne.0) return
      call gproms('table',' ',' ',intable,ierr)
      if (ierr.ne.0) return
      call gproms('output',' ',' ',output,ierr)
      if (ierr.ne.0) return
      call gproms('outtable',' ',' ',outtable,ierr)
      if (ierr.ne.0) return
      call gproms('deletion','.del .star .cosmic',' ',deletion,ierr)
      if (ierr.ne.0) return
      call gproml('imoutfl',.true.,' ',limout,ierr)
      if (ierr.ne.0) return
      call gproml('residual',.false.,' ',ldif,ierr)
      if (ierr.ne.0) return
      call gproml('calmag',.true.,' ',lmag,ierr)
      if (ierr.ne.0) return
      call gproml('emag',.true.,' ',lemag,ierr)
      if (ierr.ne.0) return
      call gproml('cmag',.true.,' ',lcmag,ierr)
      if (ierr.ne.0) return
      call gpromr('sky',0.,' ',skyval,ierr)
      if (ierr.ne.0) return
      call gpromr('ssky',0.,' ',ssky,ierr)
      if (ierr.ne.0) return
      call gpromr('ron',0.,' ',ron,ierr)
      if (ierr.ne.0) return
      call gpromr('cfactor',1.,' ',cfactor,ierr)
      if (ierr.ne.0) return
      call gpromr('zero',22.,' ',zero,ierr)
      if (ierr.ne.0) return
      call gpromr('exptime',1.,' ',exptime,ierr)
      if (ierr.ne.0) return
      call gpromr('rscale',1.,' ',rscale,ierr)
      if (ierr.ne.0) return
      call gproml('paflag',.true.,' ',paflag,ierr)
      if (ierr.ne.0) return
      call gproml('ccdflag',.true.,' ',ccdflag,ierr)
      if (ierr.ne.0) return
      call gpromr('dalpha',0.,' ',dalpha,ierr)
      if (ierr.ne.0) return
      call gpromi('hmax',4,' ',inhmax,ierr)
      if (ierr.ne.0) return
      call gpromi('npolres',4,' ',npolres,ierr)
      if (ierr.ne.0) return
      call gpromi('verbose',0,' ',debug,ierr)
      if (ierr.ne.0) return

      call gimopen (1,image, ierr)
      if (ierr.ne.0) then
         write(string,'('' MODMX: ERROR: opening '',a)') image(1:40)
         call gwrits(string,2)
         return
      end if
      call gimhead (1,object,nx,ny,ierr)
      if (ierr.ne.0) return

      if (ldif.or.lmag) then
         call  readin (1, nx, ny, pix, ierr)
         if (ierr.ne.0) return  
      end if

C     MASK FLAGGED PIXELS
      
      if (lmag) then
         call maskpix(nx,ny,pix,image,deletion)
      end if

      call imname(image,intable)

      ngal=1 
      hmax=6
      call readtable(intable,
     $     ellipsefit,ngal,nl,flag,inten,s,x,y,r,e,t,h,ierr)
      if (ierr.ne.0) return

      if (debug.ge.1) then
         write(string,'('' MODMX: number of rows = '',i5)') nl(1)
         call gwrits(string,1)
      end if 

      ngal=1
      do 10 igal=1,ngal
         if (nl(igal).eq.0) then
            write(string,'('' MODMX: ERROR: nl=0 '',i5)') nl(igal)
            call gwrits(string,2)
            return
         end if
 10   continue

      outfill=.true.

      call imname(image,output)

      if (debug.ge.1) then
         write(string,'('' MODMX: Evaluating residuals'')')
         call gwrits(string,1)
         write(string,'('' MODMX: nx ny'',2i6)') nx, ny
         call gwrits(string,1)
      end if 
      hmax = inhmax
      call modelx(nx,ny,pix,ngal,nl,inten,s,x,y,r,e,t,h,hmax,
     $     ldif,lmag,dif,ellipsefit,ierr)
      if (ierr.ne.0) return  

      if (debug.ge.1) then
         write(string,'('' MODMX: End of evaluating '')')
         call gwrits(string,1)
      end if
      
C Write image to disk if limout=.true.

      if (limout) then
         call gimwrit(output, nx, ny, dif, object,ierr) 
      end if

c CALCULATION OF MAGNITUDES INSIDE ELLIPSES AND CIRCLES
      
      if (lemag .or. lcmag) then
        
        hmax = inhmax
        call modmags(nx,ny,ngal,nl,inten,s,x,y,r,e,t,h,hmax,
     $     lemag,lcmag,dif,skyval,ssky,ron,cfactor,zero,
     $     exptime,rscale,paflag,ccdflag,dalpha,ierr)
        if (ierr.ne.0) return  

C WRITE RESULTS TO TABLE  
        
        hmax = 6
        call imname(image,outtable)

        call  magtabwrite(outtable,image,output,deletion,
     $     intable,ngal,nl,flag,inten,s,x,y,r,e,t,h,ierr)
        if (ierr.ne.0) return


     
      end if

      return
      end
