      subroutine photsim
      
      
      include 'param.inc'
      include 'declare.inc'
      include 'array.inc'
      
      character*128	image,output,intable
      character*128	string
      integer		ngal
      
      integer		nl(MAXGAL)
      logical		ellipfit,residual,intupdate,ldif
      logical		ellipsefit
      
      character*60	object
      
      call gproms('image',' ',' ',image,ierr)
      if (ierr.ne.0) return
      call gproms('table',' ',' ',intable,ierr)
      if (ierr.ne.0) return
      call gproms('output',' ',' ',output,ierr)
      if (ierr.ne.0) return
      call gproml('residual',.true.,' ',ldif,ierr)
      if (ierr.ne.0) return
      call gpromi('hmax',4,' ',hmax,ierr)
      if (ierr.ne.0) return
      call gpromi('npolres',4,' ',npolres,ierr)
      if (ierr.ne.0) return
      call gpromi('verbose',0,' ',debug,ierr)
      if (ierr.ne.0) return
      
      call gimopen (1,image, ierr)
      if (ierr.ne.0) then
         write(string,'('' PHOTSIM: ERROR: opening '',a)') image(1:40)
         call gwrits(string,2)
         return
      end if
      call gimhead (1,object,nx,ny,ierr)
      if (ierr.ne.0) return
      
      if (ldif) then
         call  readin (1, nx, ny, pix, ierr)
         if (ierr.ne.0) return
      end if
      
      call imname(image,intable)
      
      ngal=1
      call readtable(intable,
     $     ellipsefit,ngal,nl,flag,inten,s,x,y,r,e,t,h,ierr)
      if (ierr.ne.0) return
      
      if (debug.ge.1) then
         write(string,'('' PHOTSIM: number of rows = '',i5)') nl(1)
         call gwrits(string,1)
      end if

      ngal=1
      do 10 igal=1,ngal
         if (nl(igal).eq.0) then
            write(string,'('' PHOTSIM: ERROR: nl=0 '',i5)') nl(igal)
            call gwrits(string,2)
            return
         end if
 10   continue

      outfill=.true.

      call imname(image,output)
      
      if (debug.ge.1) then
         write(string,'('' PHOTSIM: Evaluating residuals'')')
         call gwrits(string,1)
      end if
      call model(nx,ny,pix,ngal,nl,inten,s,x,y,r,e,t,h,hmax,
     $     ldif,dif,ellipsefit,ierr)
      if (ierr.ne.0) return
      
      call gimwrit(output, nx, ny, dif, object,ierr)
      
      
      return
      end
