      subroutine setupfit(nx,ny,ngal,nl,xcen,ycen,flag,x,y,r,e,t,h,
     $     ierr)
      
c     subroutine sets up the x,y,r,e,t arrays for harmonical fitting
      
      integer	nl(ngal)
      real	xcen(ngal),ycen(ngal)
      
      include 'param.inc'
      include 'declare.inc'
      
      character*128	string
      
      call startsub('SETUPFIT')
      
      if (radfac.eq.0.) then
         write(string,'('' SETUPFIT: ERROR: radfac=0. '')')
         call gwrits(string,2)
         ierr=1
         return
      end if

      if (rmin.gt.rmax.and.rmax.ne.0.) then
         write(string,'('' SETUPFIT: ERROR: rmin > rmax '')')
         call gwrits(string,2)
         ierr=1
         return
      end if

      if (rmin.eq.0)   rmin=1.
      if (rmax.le.0.)  rmax=sqrt(float(nx)**2+float(ny)**2)
      if (debug.ge.3) then
         write(string,'('' SETUPFIT '',i3,2f10.2)') ngal,rmin,rmax
         call gwrits(string,1)
      end if
      
      do 10 igal=1,ngal
         
         rad=rmin
         il=0
 20      if (rad.lt.rmax) then
            if (debug.ge.3) then
               write(string,'('' SETUPFIT  r='',f10.2)') rad
               call gwrits(string,1)
            end if
            
            il=il+1
            r(1,il,igal)=rad
            x(1,il,igal)=xcen(igal)
            x(2,il,igal)=0.
            y(1,il,igal)=ycen(igal)
            y(2,il,igal)=0.
            e(1,il,igal)=0.
            e(2,il,igal)=0.
            t(1,il,igal)=0.
            t(2,il,igal)=0.
            do 30 ih=1,hmax
               do 31 is=1,2
                  h(1,is,ih,il,igal)=0.
                  h(2,is,ih,il,igal)=0.
 31            continue
 30         continue
            flag(1,il,igal)=hmax
            
            if (linear) then
               rad=rad+radfac
               r(2,il,igal)=0.5*(r(1,il,igal)+rad)
            else
               rad=rad*radfac
               r(2,il,igal)=sqrt(r(1,il,igal)*rad)
            end if	
            
            goto 20
         end if
         nl(igal)=il
         
 10   continue
      
      ierr=0
      return
      end
