      subroutine readtable(outtable,
     $     ellipsefit,ngal,nl,flag,inten,s,x,y,r,e,t,h,ierr)
      
      character*128 outtable,image,galaxy,deletion,intable
      logical  ellipsefit
      
      include 'param.inc'
      include 'declare.inc'
      
      integer  nl(MAXGAL)
      
      character*132 string
      integer       status,tbdscr
      integer       colidn(NCOLMAX)
      logical       exists
      

      call startsub('READTABLE')

      if (ngal.ne.1) then
         write(string,'(
     $        '' READTABLE: ERROR: cannot handle ngal != 1 '')')
         call gwrits(string,2)
         ierr=1
         return
      end if
      
      do 10 igal=1,ngal
         
c     CHECK IF TABLE EXISTS
         
         call uttacc(outtable,exists,status)
         if (.not.exists) then
            write(string,'('' READTABLE: ERROR: table '',a,
     $           '' does not exist '')') outtable(1:lenc(outtable))
            call gwrits(string,2)
            ierr=1
            return
         end if
         if (debug.ge.2) then
            write(string,'('' READTABLE: table '',a,
     $           '' exists '')') outtable(1:lenc(outtable))
            call gwrits(string,1)
         end if
         
C     OPEN  TABLE
         
         mode=1
         call uttopn(outtable,mode,tbdscr,ierr)
         if (ierr.ne.0) then
            write(string,'(
     $           '' READTABLE: ERROR: opening table '')')
            call gwrits(string,2)
            return
         end if
         if (debug.ge.2) then
            write(string,'('' READTABLE: opened table '')')
            call gwrits(string,1)
         end if

C     READ HEADER PARAMETERS
         
         call trformat(tbdscr,ellipsefit,ierr)
         if (ierr.ne.0) then
            write(string,'(
     $           '' READTABLE: ERROR: reading format from table '')')
            call gwrits(string,2)
            return
         end if
         if (debug.ge.2) then
            if (ellipsefit) then
               string=' READTABLE: format from table = ellipsefit'
            else
               string=' READTABLE: format from table = harmfit'
            end if
            call gwrits(string,1)
         end if
         
C     READ THE DATA
         
         call treadcols(tbdscr,igal,nl,flag,inten,s,x,y,r,e,t,h,
     $        ierr)
         if (ierr.ne.0) then
            write(string,'(
     $           '' READTABLE: ERROR: reading data from table '')')
            call gwrits(string,2)
            return
         end if
         if (debug.ge.2) then
            write(string,'('' READTABLE: read '',i4,
     $           '' rows from table '')') nl(igal)
            call gwrits(string,1)
         end if
         if (debug.ge.20) then
            call gwrits(' READTABLE: input values ',1)
            do i=1,nl(igal)
             write(string,'(8g15.7)') r(1,i,1),r(2,i,1),
     $              inten(1,i,1),x(1,i,1),
     $              y(1,i,1),e(1,i,1),t(1,i,1)
             call gwrits(string,1)
            end do
         end if
         if (ierr.ne.0) then
            write(string,'(
     $           '' READTABLE: ERROR: reading data from table '')')
            call gwrits(string,2)
            return
         end if
         
C     CLOSE THE TABLE
         
         call uttclo(tbdscr,ierr)

         if (ierr.ne.0) then
            write(string,'(
     $           '' READTABLE: ERROR: closing table '')')
            call gwrits(string,1)
            return
         end if

         if (debug.ge.2) then
            write(string,'('' READTABLE: closed table '')')
            call gwrits(string,1)
         end if
         
 10   continue
      
      ierr=0
      return
      end
      
      
      subroutine trformat(tbdscr, ellipsefit,ierr)
      
      logical ellipsefit
      integer tbdscr

      character*128 time,program

      include 'param.inc'

      call uthgtt(tbdscr,'program',program,ierr)
      if (ierr.ne.0) return
      ellipsefit=program(1:8).eq.'ellipfit'


      ierr=0
      return
      end

      subroutine trhead(tbdscr,image,galaxy,deletion,intable,
     $     ellipsefit,ierr)
      
      integer tbdscr
      character*128  image,galaxy,deletion,intable
      logical ellipsefit

      character*128 time,program

      include 'param.inc'

      call uthgtt(tbdscr,'time',time,ierr)
      if (ierr.ne.0) return
      call uthgtt(tbdscr,'program',program,ierr)
      if (ierr.ne.0) return
      ellipsefit=program.eq.'ellipsefit'

      call uthgtt(tbdscr,'image',image,ierr)
      if (ierr.ne.0) return
      call uthgtt(tbdscr,'galaxy',galaxy,ierr)
      if (ierr.ne.0) return
      call uthgtt(tbdscr,'deletion',deletion,ierr)
      if (ierr.ne.0) return
      call uthgtt(tbdscr,'intable',intable,ierr)
      if (ierr.ne.0) return
      
      call uthgti(tbdscr,'iter1',iter1,ierr)
      if (ierr.ne.0) return
      call uthgti(tbdscr,'iter2',iter2,ierr)
      if (ierr.ne.0) return
      
      call uthgti(tbdscr,'hmax',hmax,ierr)
      if (ierr.ne.0) return
      call uthgti(tbdscr,'nsammax',nsammax,ierr)
      if (ierr.ne.0) return
      call uthgti(tbdscr,'debug',debug,ierr)
      if (ierr.ne.0) return
      call uthgti(tbdscr,'npolres',npolres,ierr)
      if (ierr.ne.0) return
      
      call uthgtr(tbdscr,'rmin',rmin,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'rmax',rmax,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'radfac',radfac,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'rshap',rshap,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'rcen',rcen,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'errshap',errshap,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'errcen',errcen,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'dposmax',dposmax,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'dellmax',dellmax,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'dangmax',dangmax,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'r1',r1,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'r2',r2,ierr)
      if (ierr.ne.0) return
      call uthgtr(tbdscr,'fracmin',fracmin,ierr)
      if (ierr.ne.0) return
      call uthgtb(tbdscr,'linear',linear,ierr)
      if (ierr.ne.0) return
      call uthgtb(tbdscr,'outfill',outfill,ierr)
      if (ierr.ne.0) return

      ierr=0
      return
      end
      


      subroutine treadcols(tbdscr,igal,nl,flag,inten,s,x,y,r,e,t,h,
     $     ierr)
      
      include 'param.inc'
      include 'declare.inc'
      
      integer tbdscr,nl(MAXGAL),ierr
      
      character*30 colname(NCOLMAX),colunits(NCOLMAX),colfmt(NCOLMAX)
      integer      datatype(NCOLMAX)
      integer      colidn(NCOLMAX)
      logical      nullflag(MAXLINE)
      integer      tparm
      
      character*128 string
      real*4 buffer(MAXLINE)
      
      call startsub('TREADCOLS')

      call tcolnam(ncol,colname,colunits,colfmt,datatype)
      
      tparm=21
      call utpgti(tbdscr,tparm,nrow,ierr)
      if (ierr.ne.0) then
         call gwrits(
     $        ' TREADCOLS: ERROR: cannot get number of lines',2)
         return
      end if
      if (nrow.eq.0) then
         call gwrits(' TREADCOLS: ERROR: nrow=0 ',2)
         return
      end if

      nl(igal)=nrow
      if (debug.ge.2) then
         write(string,'('' TREADCOLS:  nrow='',i4,'' igal='',i4)') 
     $        nl(igal),igal
         call gwrits(string,1)
      end if

      
      call utcfnd(tbdscr,colname,ncol,colidn,ierr)
      if (ierr.ne.0) then
         if (debug.gt.2) 
     $    call gwrits(' TREADCOLS: ERROR in column descriptor find',2)
         return
      end if
      
      if (debug.gt.20) call gwrits(' TREADCOLS: Start read r',1)

      n1=1
      call utcgtr(tbdscr,colidn(1),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,r,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(1),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,r,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(2),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,r,2,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(3),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,inten,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(4),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,inten,2,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(5),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,s,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(6),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,s,2,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(7),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,x,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(8),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,x,2,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(9),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,y,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(10),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,y,2,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(11),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,e,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(12),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,e,2,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(13),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,t,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      call utcgtr(tbdscr,colidn(14),n1,nrow,buffer,nullflag,ierr)
      call putcol(2,t,2,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      do 25 i=1,nrow
         t(1,i,igal)=t(1,i,igal)*pi/180.
         t(2,i,igal)=t(2,i,igal)*pi/180.
 25   continue

      if (debug.gt.20) then
         call gwrits('Read in all geometric parameters',2)
      end if

      icol=14
      do 30 ihar=1,hmax
         icol=icol+1
         call utcgtr(tbdscr,colidn(icol),n1,nrow,buffer,nullflag,ierr)
         call puthcol(h,1,1,ihar,igal,nrow,buffer)
         if (ierr.ne.0) return
         icol=icol+1
         call utcgtr(tbdscr,colidn(icol),n1,nrow,buffer,nullflag,ierr)
         call puthcol(h,2,1,ihar,igal,nrow,buffer)
         if (ierr.ne.0) return
         icol=icol+1
         call utcgtr(tbdscr,colidn(icol),n1,nrow,buffer,nullflag,ierr)
         call puthcol(h,1,2,ihar,igal,nrow,buffer)
         if (ierr.ne.0) return
         icol=icol+1
         call utcgtr(tbdscr,colidn(icol),n1,nrow,buffer,nullflag,ierr)
         call puthcol(h,2,2,ihar,igal,nrow,buffer)
         if (ierr.ne.0) return
 30   continue
      
      if (debug.gt.20) then
         call gwrits('Read in all harmonics parameters',2)
      end if

      icol=icol+1
      call utcgtr(tbdscr,colidn(icol),n1,nrow,buffer,nullflag,ierr)
      call putcol(4,flag,1,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      icol=icol+1
      call utcgtr(tbdscr,colidn(icol),n1,nrow,buffer,nullflag,ierr)
      call putcol(4,flag,2,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      icol=icol+1
      call utcgtr(tbdscr,colidn(icol),n1,nrow,buffer,nullflag,ierr)
      call putcol(4,flag,3,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      icol=icol+1
      call utcgtr(tbdscr,colidn(icol),n1,nrow,buffer,nullflag,ierr)
      call putcol(4,flag,4,igal,nrow,buffer)
      if (ierr.ne.0) return
      
      
      if (debug.gt.20) then
         call gwrits('Read in all flag parameters',2)
      end if

      ierr=0
      return
      end

      subroutine putcol(ncol,array,icol,igal,nrow,buffer)

      include 'param.inc'

      real array(ncol,MAXLINE,MAXGAL)
      real buffer(MAXLINE)


      do 10 i=1,nrow
         array(icol,i,igal)=buffer(i)
 10   continue

      return
      end

      subroutine puthcol(array,icol1,icol2,icol3,igal,nrow,buffer)

      include 'param.inc'

      real array(2,2,MAXHARM,MAXLINE,MAXGAL)
      real buffer(MAXLINE)

      do 10 i=1,nrow
         array(icol1,icol2,icol3,i,igal)=buffer(i)
 10   continue

      return
      end
