      subroutine writetable(outtable,image,galaxy,deletion,intable,
     $     ellipsefit,ngal,nl,flag,inten,s,x,y,r,e,t,h,ierr)
      
      character*128 outtable,image,galaxy,deletion,intable
      logical  ellipsefit
      integer  nl(ngal)
      
      include 'param.inc'
      include 'declare.inc'
      
      
      character*132 string
      integer       status
      integer       colidn(NCOLMAX)
      logical       exists
      

      call startsub('WRITETABLE')

      if (ngal.gt.1) then
         write(string,'(
     $        '' WRITETABLE: ERROR: cannot handle ngal > 1 '')')
         call gwrits(string,2)
         ierr=1
         return
      end if
      
      do 10 igal=1,ngal
         
c     CHECK IF TABLE EXISTS
         
         call uttacc(outtable,exists,status)
         if (exists) then
            write(string,'('' WRITETABLE: ERROR: table '',a,
     $           '' exits already '')') outtable(1:lenc(outtable))
            call gwrits(string,2)
            ierr=1
            return
         end if
         if (debug.ge.2) then
            write(string,'('' WRITETABLE: table '',a,
     $           '' does not yet exist '')') outtable(1:lenc(outtable))
            call gwrits(string,1)
         end if
         
C     INITIALIZE TABLE
         
         call uttinn(outtable,tbdscr,ierr)
         if (ierr.ne.0) then
            write(string,'(
     $           '' WRITETABLE: ERROR: initializing table '')')
            call gwrits(string,1)
            return
         end if
         if (debug.ge.2) then
            write(string,'('' WRITETABLE: initialized table '')')
            call gwrits(string,1)
         end if
         
C     DEFINE COLUMNS
         
         call tcoldef(tbdscr,status,ncol,colidn,ierr)
         if (ierr.ne.0) return
         if (debug.ge.2) then
            write(string,'('' WRITETABLE: defined columns '')')
            call gwrits(string,1)
         end if
         
C     CREATE THE TABLE
         
         call uttcre(tbdscr,ierr)
         if (ierr.ne.0) then
            write(string,'(
     $           '' WRITETABLE: ERROR: creating table '')')
            call gwrits(string,1)
            return
         end if

         if (debug.ge.2) then
            write(string,'('' WRITETABLE: created table '')')
            call gwrits(string,1)
         end if
         
C     WRITE THE HEADER PARAMETERS
         
         call thead(tbdscr,image,galaxy,deletion,intable,ellipsefit,
     $        ierr)
         if (ierr.ne.0) then
            write(string,'(
     $           '' WRITETABLE: ERROR: writing header to table '')')
            call gwrits(string,1)
            return
         end if
         if (debug.ge.2) then
            write(string,'('' WRITETABLE: wrote header to table '')')
            call gwrits(string,1)
         end if
         
C     WRITE THE DATA
         
         call twritcols(tbdscr,igal,nl,flag,inten,s,x,y,r,e,t,h,
     $        ierr)
         if (ierr.ne.0) then
            write(string,'(
     $           '' WRITETABLE: ERROR: writing data to table '')')
            call gwrits(string,1)
            return
         end if
         if (debug.ge.2) then
            write(string,'('' WRITETABLE: wrote values to table '')')
            call gwrits(string,1)
         end if
         
C     CLOSE THE TABLE
         
         call uttclo(tbdscr,ierr)

         if (ierr.ne.0) then
            write(string,'(
     $           '' WRITETABLE: ERROR: closing table '')')
            call gwrits(string,1)
            return
         end if

         if (debug.ge.2) then
            write(string,'('' WRITETABLE: closed table '')')
            call gwrits(string,1)
         end if
         
 10   continue
      
      ierr=0
      return
      end
      
      

      subroutine tcoldef(tbdscr,status,ncol,colidn,ierr)
      
C     DEFINE THE COLUMN NAMES & FORMATS
      
      include 'param.inc'
      
      integer tbdscr,status
      integer colidn(NCOLMAX)
      
      
      character*30 colname(NCOLMAX),colunits(NCOLMAX),colfmt(NCOLMAX)
      integer      datatype(NCOLMAX)
      
      call tcolnam(ncol,colname,colunits,colfmt,datatype)
      
      call utcdef(tbdscr,colname,colunits,colfmt,datatype,ncol,
     $     colidn,ierr)
      
      
      return
      end
      
      subroutine tcolnam(ncol,colname,colunits,colfmt,datatype)
      
C     DEFINE THE COLUMN NAMES & FORMATS
      
      include 'param.inc'
      
      character*30 colname(NCOLMAX),colunits(NCOLMAX),colfmt(NCOLMAX)
      integer      datatype(NCOLMAX)
      
      
      colname(1)='r'
      colfmt(1)='f6.2'
      colname(2)='dr'
      colfmt(2)='f5.2'
      
      colname(3)='i'
      colfmt(3)='g7.2'
      colname(4)='e_i'
      colfmt(4)='g5.2'
      colname(5)='s'
      colfmt(5)='f7.2'
      colname(6)='e_s'
      colfmt(6)='f5.2'
      colname(7)='x'
      colfmt(7)='f6.2'
      colname(8)='e_x'
      colfmt(8)='f6.2'
      colname(9)='y'
      colfmt(9)='f6.2'
      colname(10)='e_y'
      colfmt(10)='f6.2'
      colname(11)='eps'
      colfmt(11)='f6.4'
      colname(12)='e_eps'
      colfmt(12)='f6.4'
      colname(13)='pos'
      colfmt(13)='f6.1'
      colname(14)='e_pos'
      colfmt(14)='f6.1'
      
      icol=14
      do 20 ihar=1,hmax
         icol=icol+1
         write(colname(icol),'(''c'',i1)') ihar
         colfmt(icol)='f7.4'
         icol=icol+1
         colname(icol)='e_'//colname(icol-1)
         colfmt(icol)='f7.4'
         icol=icol+1
         write(colname(icol),'(''s'',i1)') ihar
         colfmt(icol)='f7.4'
         icol=icol+1
         colname(icol)='e_'//colname(icol-1)
         colfmt(icol)='f7.4'
 20   continue
      
      icol=icol+1
      colname(icol)='f1'
      colfmt(icol)='f6.2'
      icol=icol+1
      colname(icol)='f2'
      colfmt(icol)='f6.2'
      icol=icol+1
      colname(icol)='f3'
      colfmt(icol)='f6.2'
      icol=icol+1
      colname(icol)='f4'
      colfmt(icol)='f6.2'
      
      
      ncol=icol
      
      do 10 i=1,ncol
         colunits(i)=' '
         datatype(i)=6
 10   continue
      
      return
      end

      subroutine thead(tbdscr,image,galaxy,deletion,intable,
     $     ellipsefit,ierr)
      
      character*128  image,galaxy,deletion,intable
      logical ellipsefit

      include 'param.inc'

      call uthadt(tbdscr,'time','???',ierr)
      if (ierr.ne.0) return
      if (ellipsefit) then
         call uthadt(tbdscr,'program','ellipfit',ierr)
         if (ierr.ne.0) return
      else
         call uthadt(tbdscr,'program','harmfit',ierr)
         if (ierr.ne.0) return
      end if
      
      call uthadt(tbdscr,'image',image,ierr)
      if (ierr.ne.0) return
      call uthadt(tbdscr,'galaxy',galaxy,ierr)
      if (ierr.ne.0) return
      call uthadt(tbdscr,'deletion',deletion,ierr)
      if (ierr.ne.0) return
      call uthadt(tbdscr,'intable',intable,ierr)
      if (ierr.ne.0) return
      
      call uthadi(tbdscr,'iter1',iter1,ierr)
      if (ierr.ne.0) return
      call uthadi(tbdscr,'iter2',iter2,ierr)
      if (ierr.ne.0) return
      
      call uthadi(tbdscr,'hmax',hmax,ierr)
      if (ierr.ne.0) return
      call uthadi(tbdscr,'nsammax',nsammax,ierr)
      if (ierr.ne.0) return
      call uthadi(tbdscr,'debug',debug,ierr)
      if (ierr.ne.0) return
      call uthadi(tbdscr,'npolres',npolres,ierr)
      if (ierr.ne.0) return
      
      call uthadr(tbdscr,'rmin',rmin,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'rmax',rmax,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'radfac',radfac,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'rshap',rshap,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'rcen',rcen,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'errshap',errshap,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'errcen',errcen,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'dposmax',dposmax,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'dellmax',dellmax,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'dangmax',dangmax,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'r1',r1,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'r2',r2,ierr)
      if (ierr.ne.0) return
      call uthadr(tbdscr,'fracmin',fracmin,ierr)
      if (ierr.ne.0) return
      call uthadb(tbdscr,'linear',linear,ierr)
      if (ierr.ne.0) return
      call uthadb(tbdscr,'outfill',outfill,ierr)
      if (ierr.ne.0) return
      
      return
      end
      
      subroutine twritcols(tbdscr,igal,nl,flag,inten,s,x,y,r,e,t,h,
     $     ierr)
      
      include 'param.inc'
      include 'declare.inc'
      
      integer tbdscr,nl(igal),ierr
      
      character*30 colname(NCOLMAX),colunits(NCOLMAX),colfmt(NCOLMAX)
      integer      datatype(NCOLMAX)
      integer      colidn(NCOLMAX)
      
      real*4 buffer(MAXLINE)
      
      call tcolnam(ncol,colname,colunits,colfmt,datatype)
      
      nrow=nl(igal)
      
      call utcfnd(tbdscr,colname,ncol,colidn,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,r,1,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(1),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,r,2,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(2),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,inten,1,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(3),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,inten,2,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(4),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,s,1,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(5),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,s,2,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(6),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,x,1,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(7),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,x,2,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(8),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,y,1,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(9),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,y,2,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(10),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,e,1,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(11),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,e,2,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(12),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,t,1,igal,nrow,buffer)
      do 25 i=1,nrow
         buffer(i)=buffer(i)*180./pi
 25   continue
      call utcptr(tbdscr,colidn(13),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      call selcol(2,t,2,igal,nrow,buffer)
      do 26 i=1,nrow
         buffer(i)=buffer(i)*180./pi
 26   continue
      call utcptr(tbdscr,colidn(14),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      icol=14
      do 30 ihar=1,hmax
         icol=icol+1
         call selcolh(h,1,1,ihar,igal,nrow,buffer)
         call utcptr(tbdscr,colidn(icol),1,nrow,buffer,ierr)
         if (ierr.ne.0) return
         icol=icol+1
         call selcolh(h,2,1,ihar,igal,nrow,buffer)
         call utcptr(tbdscr,colidn(icol),1,nrow,buffer,ierr)
         if (ierr.ne.0) return
         icol=icol+1
         call selcolh(h,1,2,ihar,igal,nrow,buffer)
         call utcptr(tbdscr,colidn(icol),1,nrow,buffer,ierr)
         if (ierr.ne.0) return
         icol=icol+1
         call selcolh(h,2,2,ihar,igal,nrow,buffer)
         call utcptr(tbdscr,colidn(icol),1,nrow,buffer,ierr)
         if (ierr.ne.0) return
 30   continue
      
      icol=icol+1
      call selcol(4,flag,1,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(icol),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      icol=icol+1
      call selcol(4,flag,2,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(icol),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      icol=icol+1
      call selcol(4,flag,3,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(icol),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      icol=icol+1
      call selcol(4,flag,4,igal,nrow,buffer)
      call utcptr(tbdscr,colidn(icol),1,nrow,buffer,ierr)
      if (ierr.ne.0) return
      
      ierr=0
      return
      end

      subroutine selcol(ncol,array,icol,igal,nrow,buffer)

      include 'param.inc'

      real array(ncol,MAXLINE,MAXGAL)
      real buffer(MAXLINE)


      do 10 i=1,nrow
         buffer(i)=array(icol,i,igal)
 10   continue

      return
      end

      subroutine selcolh(array,icol1,icol2,icol3,igal,nrow,buffer)

      include 'param.inc'

      real array(2,2,MAXHARM,MAXLINE,MAXGAL)
      real buffer(MAXLINE)

      do 10 i=1,nrow
         buffer(i)=array(icol1,icol2,icol3,i,igal)
 10   continue

      return
      end

