      subroutine vecmedian(pix, npix, nwin, medpix,ierr)
      
      real pix(npix),medpix(npix)
      real buf(129)
      
      if (nwin.le.0.or.nwin.ge.64) then
         ierr=-1
         return
      end if
      
      do 10 i=1,npix
         i0=i-nwin
         i1=i+nwin
         if (i0.le.1) i0=1
         if (i1.ge.npix) i1=npix
         nbuf=0
         do 11 j=i0,i1
            nbuf=nbuf+1
            buf(nbuf)=pix(j)
 11      continue
         ksel=(i1-i0)/2+1
         medpix(i)=selpix(buf,(i1-i0+1),ksel)
 10   continue
      
      return
      end

      real function selpix (a, npix, ksel)

c This routine is lifted from IRAF/NOAO
c Copyright(c) 1986 Association of Universities for Research in Astronomy Inc.
c
c ASOK -- Select the Kth smallest element from a vector.  The algorithm used
c is selection by tail recursion (Gonnet 1984).  In each iteration a pivot key
c is selected (somewhat arbitrarily) from the array.  The array is then split
c into two subarrays, those with key values less than or equal to the pivot key
c and those with values greater than the pivot.  The size of the two subarrays
c determines which contains the median value, and the process is repeated
c on that subarray, and so on until all of the elements of the subarray
c are equal, e.g., there is only one element left in the subarray.  For a
c randomly ordered array the expected running time is O(3.38N).  The selection
c is carried out in place, leaving the array in a partially ordered state.
c
c N.B.: Behaviour is O(N) if the input array is sorted.
c N.B.: The cases ksel=1 and ksel=npix, i.e., selection of the minimum and
c maximum values, are more efficiently handled by ALIM which is O(2N).


      integer npix
      integer ksel
      real a(32767)
      integer lo
      integer up
      integer i
      integer j
      integer k
      real temp
      save
         lo = 1
         up = npix
         k = max (lo, min (up, ksel))
110      if (.not.(up .ge. k .and. k .ge. lo)) goto 111
            i = lo
            j = up
            temp = a(k)
            a(k) = a(lo)
            a(lo) = temp
120         if (.not.(i .lt. j)) goto 121
130            if (.not.(a(j) .gt. temp)) goto 131
                  j = j - 1
                  goto 130
131            continue
               a(i) = a(j)
140            if (.not.(i .lt. j .and. a(i) .le. temp)) goto 141
                  i = i + 1
                  goto 140
141            continue
               a(j) = a(i)
               goto 120
121         continue
            a(i) = temp
            if (.not.(k .lt. i)) goto 150
               up = i - 1
               goto 151
150         continue
               lo = i + 1
151         continue
            goto 110
111      continue
         selpix = (a(k))
         goto 100
100      return
      end
